
;; /////////////////////////////////////////////////////////
;;
;; CAPITOL 2, 5 & 8
;;   
;; Implementarea stream-urilor infinite
;;  fisier stream.lsp
;;
;;//////////////////////////////////////////////////////////

(defmacro delay (exp)
  "Intarzie evaluarea expresiei"
   `(function (lambda () ,exp)))

(defun force (function-closure)
   "forteaza evaluarea lui function-closure"
   (if (functionp function-closure)
      (funcall function-closure)
      (make-stream-vid)))

(defmacro cons-stream (exp stream) 
   `(cons ,exp (delay ,stream)))


(defun head-stream (stream)
   (car stream))

(defun tail-stream (stream)
   (force (cdr stream)))


(defun stream-vid-p (stream)
   ;; testeaza daca stream e vid
   (null stream))

(defun make-stream-vid()
   ;; creaza un stream vid
   nil)

(defun mod-stream (subst tree fun-closure)
   "Modifica un stream"
   ;; NU INTARZIE EVALUAREA ! 
   ;; Argumentele sunt preparate dinainte
   (cons (list subst tree) fun-closure))

(defun comb-f (stream1 stream2)  
   (if (stream-vid-p stream1)
      (force stream2)
      (cons-stream (head-stream stream1)
        (comb-f (tail-stream stream1) stream2))))
   
(defmacro combina-streamuri (stream1 stream2)
   ;; combina 2 streamuri fara a le evalua
   `(comb-f ,stream1 (delay ,stream2)))


(defun filtreaza-stream (stream pred)
   ;; filtreaza un stream prin predicat (sterge toate 
   ;; elem din stream care satisfac pred)  
   (if (null stream)
      (make-stream-vid)
      (if (not (funcall pred (head-stream stream)))
         (cons-stream (head-stream stream) (filtreaza-stream (tail-stream stream) pred))
         (filtreaza-stream (tail-stream stream) pred))))
     

(defun map-stream (stream function)
   (if (stream-vid-p stream)
      (make-stream-vid)
      (cons-stream (funcall function (head-stream stream))
        (map-stream (tail-stream stream) function))))

(defun print-stream (stream)
   (if (stream-vid-p stream)
      nil
      (progn
        (print (head-stream stream))
        (print-stream (tail-stream stream)))))