;; /////////////////////////////////////////////////////////////
;;
;; CAPITOL 5 & 8
;;  
;; Prelucrarea solutiei
;; Fisier solutie.lsp
;;
;;/////////////////////////////////////////////////////////////

;; solutie este un stream ce contine o lista de substitutii
;; arborele ce explica concluzia si o inchidere functionala care,
;; fortata, produce noi solutii, daca acestea exista.
;;  Solutie are forma:
;; ( (substitutii arbore-expl) . (#function-closure))

(defun solutie-subst (solutie)
   (first solutie))

(defun solutie-arbore (solutie)
   (second solutie))

(defun stream-solutie-subst (stream-solutie)
   "Intoarce substitutiile din stream-solutie"
   (solutie-subst (head-stream stream-solutie)))

(defun stream-solutie-arbore (stream-solutie)
  "Intoarce arborele de explicatie din stream-solutie"
  (solutie-arbore (head-stream stream-solutie)))

(defun solutie-stream-fun-closure (stream-solutie)
   "Intoarce inchiderea functionala din stream-solutie"
   (cdr stream-solutie))



;; ////////////// Functii pentru afisare
      
(defun print-solutie (concl stream-solutie)
   (cond ((stream-vid-p stream-solutie) nil)
         (t (print (aplic-subst concl (solutie-subst (head-stream stream-solutie))))
           (let ((arbore (solutie-arb (head-stream stream-solutie)))
                 (subst (solutie-subst (head-stream stream-solutie))))
              (print-arbore (generalizeaza-arbore  
                             (filtreaza-arbore arbore () 'radacina) subst) 'radacina)
              (terpri)  
              (print-solutie concl (tail-stream stream-solutie))))))
   

