;;///////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.2 Strategii de cautare euristica
;;3.2.1 Cautare informata de tip "best-first"
;;
;;///////////////////////////////////////////////////////

;; "bestfirst.lsp" - cautare a solutiei si a caii pana la solutie folosind 
;; strategia "best-first". Spatiul de cautare este un graf. Cele doua functii 
;; folosite (w si ww) simuleaza cautare pe nivel si respectiv in adancime
 
(defparameter *STARE-FINALA* 18)
(defparameter *LIM* 10)
(defparameter *SOLUTII* nil)

(defun succf(x) (if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

(defstruct cale stare w (predec nil))

(defun insert (x lista-ord)
   (cond ((null lista-ord) (list x))
          ((<= (cale-w x) (cale-w (first lista-ord)))
              (cons x lista-ord))
       (t (cons (first lista-ord) 
    (insert x (rest lista-ord))))))

(defun test-st* (stare FRONTIERA)
   (labels ((test (x lst1 lst2) 
              (cond 
                ((null lst2) 
                 (values nil lst1 nil lst2))
                ((equal x (cale-stare (first lst2))) 
                 (values t lst1 (first lst2) (rest lst2)))
                (t (let (flag l1 e l2)
                     (multiple-value-setq (flag l1 e l2)
                         (test x (append lst1 (list (first lst2)))
                            (rest lst2)))
                     (values flag l1 e l2)))))) 
     (test (cale-stare stare) nil FRONTIERA)))

(defun succf* (x fct-w)
   (let ((ss (cale-stare x)) (ww (cale-w x)))
      (mapcar #'(lambda (y) 
                  (make-cale :stare y  
                     :w (funcall fct-w x) :predec x))
              (succf ss))))

(defun estescop* (x) 
   (equal (cale-stare x) *STARE-FINALA*))

(defun cautcale (FRONTIERA scop succesori TERITORIU test-st fct-w)
   (format t"~& CAUT: ~a" (first FRONTIERA))
   (cond 
     ((null FRONTIERA) nil)
     ((funcall scop (first FRONTIERA)) (first FRONTIERA))
     (t 
      (let ((succlist 
            (funcall succesori (first FRONTIERA) fct-w)))
        (setf TERITORIU 
           (insert (first FRONTIERA) TERITORIU))      
        (setf FRONTIERA (rest FRONTIERA))
        (do ((crt succlist (rest crt)) )
            ((null crt) nil)
          (let (flag l1 elem l2)
            (multiple-value-setq (flag l1 elem l2) 
                (funcall test-st (first crt) FRONTIERA))
            (if flag
              (if (< (cale-w (first crt)) (cale-w elem))
                (setf FRONTIERA (insert (first crt) (append l1 l2))))
                (progn
                 (multiple-value-setq (flag l1 elem l2) 
                  (funcall test-st (first crt) TERITORIU))
                  (if flag
                    (if (< (cale-w (first crt)) 
                           (cale-w elem))
                      (progn 
                        (setf FRONTIERA 
                           (insert (first crt) FRONTIERA))
                        (setf TERITORIU (append l1 l2))))
                    (setf FRONTIERA 
                      (insert (first crt) FRONTIERA)))))))
        (cautcale FRONTIERA scop succesori TERITORIU test-st fct-w)))))

(defun w (x) (1+ (cale-w x)))

(defun ww (x) (1- (cale-w x)))

;;(defun www (x) 
;;   (+ (cale-w x) 
;;      (cost-operator 
;;          (cale-stare (cale-predec x)) (cale-stare x))))
;;unde cost-operator nu este definita aici.

;;Exemple de apel
(cautcale (list (make-cale :stare 1 :w 0)) #'estescop* #'succf* 
  nil #'test-st* #'w)
(cautcale (list (make-cale :stare 1 :w 0)) #'estescop* #'succf* 
  nil #'test-st* #'ww)