;;/////////////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.2 Strategii de cautare euristica
;;3.2.2 Cautarea solutiei optime: algoritmul A*
;;
;;//////////////////////////////////////////////////////////////

;; "astar.lsp" - gasirea solutiei si a caii pana la solutie, folosind 
;; algoritmul A*. Spatiul de cautare este un graf

(defparameter *FINAL* 18)
(defparameter *LIM* 10)
(defparameter *SOLUTII* nil)
(defparameter *INITIAL* 1)

(defun succf(x) (if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

(defstruct cale stare g h f (predec nil))

(defun insert (x lista-ord)
   (setf (cale-f x) (+ (cale-g x) (cale-h x)))
   (cond ((null lista-ord) (list x))
          ((<= (cale-f x) (cale-f (first lista-ord)))
              (cons x lista-ord))
       (t (cons (first lista-ord) (insert x (rest lista-ord))))))

(defun succf* (x fct-h fct-g)
   (let ((xx (cale-stare x)))
        (mapcar #'(lambda (y) (make-cale :stare y :g (funcall fct-g y x) 
                                                  :h (funcall fct-h y) :predec x))
              (succf xx))))              

(defun estescop* (x) (equal (cale-stare x) *FINAL*))
   
(defun test-st* (stare FRONTIERA)
   (labels ((test (x lst1 lst2) 
               (cond ((null lst2) (values nil lst1 nil lst2))
                     ((equal x (cale-stare (first lst2))) 
                         (values t lst1 (first lst2) (rest lst2)))
                   (t (let (flag l1 e l2)
                         (multiple-value-setq (flag l1 e l2)
                                  (test x (append lst1 (list (first lst2)))
                                          (rest lst2)))
                         (values flag l1 e l2)))))) 
     (test (cale-stare stare) nil FRONTIERA)))

(defun cautcale (FRONTIERA scop succesori TERITORIU test-st fct-h fct-g)
(format t"~& CAUT: ~a" (first FRONTIERA))
(cond 
 ((null FRONTIERA) nil)
 ((funcall scop (first FRONTIERA)) (print (first FRONTIERA)))
 (t 
  (let ((succlist (funcall succesori (first FRONTIERA) fct-h fct-g)))
   ;;(print (cale-g (first FRONTIERA)))
   (setf TERITORIU (insert (first FRONTIERA) TERITORIU))      
   (setf FRONTIERA (rest FRONTIERA))
   (do ((crt succlist (rest crt)) )
         ((null crt) nil)
      (let (flag l1 elem l2)
         (multiple-value-setq (flag l1 elem l2) 
                              (funcall test-st (first crt) FRONTIERA))
         (if flag
            (if (< (cale-g (first crt)) (cale-g elem))
               (setf FRONTIERA (insert (first crt)
                                  (append l1 l2))))
            (progn
             (multiple-value-setq (flag l1 elem l2) 
                                  (funcall test-st (first crt) TERITORIU))
             (if flag
                 (if (< (cale-g (first crt)) (cale-g elem))
                    (progn 
                      (setf FRONTIERA (insert (first crt) FRONTIERA))
                      (setf TERITORIU (append l1 l2))))
                 (setf FRONTIERA (insert (first crt) FRONTIERA)))))))
    (cautcale FRONTIERA scop succesori TERITORIU test-st fct-h fct-g)))))



(defun g (stare-noua cale-veche)
   (+ 1 (cale-g cale-veche)))

;;Pentru exemplul considerat, nu are sens utilizarea unei euristici.
;;In sectiunea 3.3 este utilizat algoritmul A* pentru rezolvarea problemei
;;mozaicului cu 8 cifre si se prezinta mai multe functii euristice
(defun h (stare) 0)

;;Exemplu de apel
(cautcale (list (make-cale :stare *INITIAL* :g 0 :h 0 :f 0)) 
  #'estescop* #'succf* '() #'test-st* #'h #'g)