;;////////////////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.1 Strategii de cautare neinformata
;;3.1.3 Cautare pe nivel
;;
;;/////////////////////////////////////////////////////////////////

;; "cautcale.lsp" - cautare parametrizata cu gasirea caii la solutie; 
;; spatiul de cautare este un graf 

(defparameter *FINAL* 18)
(defparameter *STFINALE* '(18 10 14))
(defparameter *LIM* 10)
(defparameter *SOLUTII* nil)

(defun estescop (x) (equal x *FINAL*))

(defun succf(x) (if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

(defstruct cale stare (predecesor nil))

(defun expand-cale (FRONTIERA succesori TERITORIU test-st)
(let ((curenta (first FRONTIERA)))
 (mapcar #'(lambda (noua)
              (make-cale :stare noua  :predecesor  curenta))
         (remove-if #'(lambda (st)
                         (or (funcall test-st st FRONTIERA)
                             (funcall test-st st TERITORIU)))
                    (funcall succesori (cale-stare curenta))))))

(defun afis-cale (stare)
(do ((curenta stare (cale-predecesor curenta)))
    ((null (cale-predecesor curenta))
           (format t "~& STARE: ~a" (cale-stare curenta)))
    (format t "~& STARE: ~a" (cale-stare curenta))))

(defun scopcale (x)
(equal (cale-stare x) *FINAL*))

(defun adaug (stare TERITORIU test-st)
(if (funcall test-st stare TERITORIU) 
  TERITORIU 
  (cons stare TERITORIU)))

(defun estein (elem lista)
"Un exemplu de parametru actual care instantiaza parametrul formal test-st"
(some #'(lambda (x)
                (equal elem (cale-stare x)))
      lista))

(defun cautgraf (FRONTIERA scop succesori strategie TERITORIU test-st)
  (format t "~& CAUT: ~a" (first FRONTIERA))
  (cond 
      ((null FRONTIERA) nil)
      ((funcall scop (first FRONTIERA)) (first FRONTIERA))
      (t (cautgraf
            (funcall strategie 
                     (expand-cale FRONTIERA succesori TERITORIU test-st)
                     (rest FRONTIERA))
            scop succesori strategie
            (adaug (first FRONTIERA) TERITORIU test-st)        
            test-st))))

(defun la-urma (succesori FRONTIERA)
(append FRONTIERA succesori))

(defun cautcale-lat (init scop succesori)
(cautgraf
         (list (make-cale :stare init))
         scop succesori #'la-urma nil #'estein))

(defun cautcale-adanc (init scop succesori)
(cautgraf
         (list (make-cale :stare init))
         scop succesori #'append nil #'estein))

;;Exemple de apel
(afis-cale (cautcale-lat 1 #'scopcale #'succf))
(afis-cale (cautcale-adanc 1 #'scopcale #'succf))


