;;///////////////////////////////////////////////////////////////
;;
;;3 Strategii de cautare
;;3.1 Strategii de cautere neinformata
;;3.1.3 Cautarea pe nivel
;;
;;///////////////////////////////////////////////////////////////

;; "cautgraf.lsp" - cautare genereala, cand spatiul starilor este un graf
;; strategia de cautare, modul de determinare a succesorilor si testul starii
;; finale sunt parametri

(defparameter *FINAL* 18)
(defparameter *STFINALE* '(18 10 14))
(defparameter *LIM* 10)
(defparameter *SOLUTII* nil)

(defun estescop (x) (equal x *FINAL*))

(defun succf(x) (if (< x *LIM*) (list (* 2 x) (+ 1 (* 2 x)))))

(defun cautgraf (FRONTIERA scop succesori strategie TERITORIU)
  (format t "~& CAUT: ~a" FRONTIERA)
  (cond ((null FRONTIERA) nil)
      ((funcall scop (first FRONTIERA)) (first FRONTIERA))
      (t (cautgraf(funcall strategie (expand FRONTIERA succesori TERITORIU)
            (rest FRONTIERA)) scop succesori strategie
            (adaug (first FRONTIERA) TERITORIU)))))

(defun expand (FRONTIERA succesori TERITORIU)
   (remove-if
      #'(lambda (stare)
           (or (member stare FRONTIERA)
               (member stare TERITORIU)))
      (funcall succesori (first FRONTIERA))))

(defun adaug (stare TERITORIU)
   (if (member stare TERITORIU)
      TERITORIU
      (cons stare TERITORIU)))

(defun cautgraf-lat (init scop succesori)
   (cautgraf (list init) scop succesori #'la_urma nil))

(defun cautgraf-adanc (init scop succesori)
   (cautgraf (list init) scop succesori #'append nil))

;;Exemple de apel
(cautgraf-lat 1 #'estescop #'succf)
(cautgraf-adanc 1 #'estescop #'succf)
