;;/////////////////////////////////////////////////////////////////
;;3 Strategii de cautare
;;
;;3.3 Rezolvarea problemelor utilizand strategii de cautare
;;3.3.1 Problema misionarilor si canibalilor
;;
;;//////////////////////////////////////////////////////////////////

;; "misionari.lsp" - *nce* canibali si *nme* misionari trebuie sa treaca de pe 
;; un mal pe celalalt intr-o barca cu *b* locuri. Numarul de misionari trebuie 
;; sa fie mai mare sau egal cu numarul canibalilor in orice loc. Problema este 
;; rezolvata utilizand algoritmul A*

(defparameter *b* 2)

(defparameter *nce* 3)

(defparameter *nme* 3)

(defparameter *ncv* 0)

(defparameter *nmv* 0)

(defparameter *STARE-INITIALA* 
`(,*nce* ,*nme* ,*ncv* ,*nmv* e))

(defparameter *STARE-FINALA* 
`(,*ncv* ,*nmv* ,*nce* ,*nmv* v))

(defun succf (x)
   (let ((nce (first x)) (nme (cadr x)) 
         (ncv (caddr x)) (nmv (cadddr x))
         (b (first (cddddr x))))
      (if (equal b 'v) 
         (combinatii nce nme ncv nmv 'v)
         (combinatii nce nme ncv nmv 'e))))

(defun combinatii (nce nme ncv nmv b)
  (let (rezultat)
    (if (equal b 'e) 
     (do ((x *b* (- x 1)))
         ((= x 0) )
        (do ((i x (- i 1)))
            ((< i 0))
          (if (and (>= nce i) (>= nme (- x i))
                   (valid (- nce i) (- nme (- x i)) 
                       (+ ncv i) (+ nmv (- x i)) 'v ))
            (setf rezultat 
              (cons (list  (- nce i) (- nme (- x i)) 
                       (+ ncv i) (+ nmv (- x i)) 'v) 
                  rezultat)))))
     (do ((x *b* (- x 1)))
         ((= x 0) )
       (do ((i x (- i 1)))
           ((< i 0))
         (if (and (>= ncv i) (>= nmv (- x i))
                  (valid (+ nce i) (+ nme (- x i)) 
                         (- ncv i) (- nmv (- x i)) 'e ))
           (setf rezultat 
             (cons (list  (+ nce i) (+ nme (- x i)) 
                      (- ncv i) (- nmv (- x i)) 'e) 
                 rezultat))))))
    rezultat))

(defun valid (nce nme ncv nmv b)
   (and (or (= nme 0) (>= nme nce))
        (or (= nmv 0) (>= nmv ncv))))

(defun h (x)
   (let* ((nce (first x)) (nme (cadr x)) 
         (ne (+ nce nme))
         (b (first (cddddr x))))
      (if (> ne 0)
         (if (equal b 'v)
            (+ 1 ne)
            (- 1 ne))
         0)))

(defstruct cale stare g h f (predec nil))
      
(defun g (stare nod-preced)
    (1+ (cale-g nod-preced)))

(defun insert (x lista-ord)
   (setf (cale-f x) (+ (cale-g x) (cale-h x)))
   (cond ((null lista-ord) (list x))
          ((<= (cale-f x) (cale-f (first lista-ord)))
              (cons x lista-ord))
       (t (cons (first lista-ord) (insert x (rest lista-ord))))))

(defun succf* (x fct-h fct-g)
   (let ((xx (cale-stare x)))
        (mapcar #'(lambda (y) (make-cale :stare y :g (funcall fct-g y x) 
                                                  :h (funcall fct-h y) :predec x))
              (succf xx))))              

(defun estescop* (x) (equal (cale-stare x) *STARE-FINALA*))
   
(defun test-st* (stare FRONTIERA)
   (labels ((test (x lst1 lst2) 
               (cond ((null lst2) (values nil lst1 nil lst2))
                     ((equal x (cale-stare (first lst2))) 
                         (values t lst1 (first lst2) (rest lst2)))
                   (t (let (flag l1 e l2)
                         (multiple-value-setq (flag l1 e l2)
                                  (test x (append lst1 (list (first lst2)))
                                          (rest lst2)))
                         (values flag l1 e l2)))))) 
     (test (cale-stare stare) nil FRONTIERA)))

(defun cautcale (FRONTIERA scop succesori TERITORIU test-st fct-h fct-g)
(format t"~& CAUT: ~a" (first FRONTIERA))
(cond 
 ((null FRONTIERA) nil)
 ((funcall scop (first FRONTIERA)) (print (first FRONTIERA)))
 (t 
  (let ((succlist (funcall succesori (first FRONTIERA) fct-h fct-g)))
   ;;(print (cale-g (first FRONTIERA)))
   (setf TERITORIU (insert (first FRONTIERA) TERITORIU))      
   (setf FRONTIERA (rest FRONTIERA))
   (do ((crt succlist (rest crt)) )
         ((null crt) nil)
      (let (flag l1 elem l2)
         (multiple-value-setq (flag l1 elem l2) 
                              (funcall test-st (first crt) FRONTIERA))
         (if flag
            (if (< (cale-g (first crt)) (cale-g elem))
               (setf FRONTIERA (insert (first crt)
                                  (append l1 l2))))
            (progn
             (multiple-value-setq (flag l1 elem l2) 
                                  (funcall test-st (first crt) TERITORIU))
             (if flag
                 (if (< (cale-g (first crt)) (cale-g elem))
                    (progn 
                      (setf FRONTIERA (insert (first crt) FRONTIERA))
                      (setf TERITORIU (append l1 l2))))
                 (setf FRONTIERA (insert (first crt) FRONTIERA)))))))
    (cautcale FRONTIERA scop succesori TERITORIU test-st fct-h fct-g)))))

;;Exemplu de apel
(cautcale (list (make-cale :stare *STARE-INITIALA* :g 0 :h 0 :f 0)) 
  #'estescop* #'succf* '() #'test-st* #'h #'g)